From f527c3d2e29c2c0e5bdaba80073b71b8ad536fcb Mon Sep 17 00:00:00 2001
From: "Jason R. Coombs" <jaraco@jaraco.com>
Date: Mon, 5 Mar 2018 15:33:44 -0500
Subject: [PATCH] Honoring PEP 479, don't allow StopIteration to bubble up.
 Fixes #3.

---
 CHANGES.rst         |  6 ++++++
 jaraco/itertools.py | 12 +++++++++---
 2 files changed, 15 insertions(+), 3 deletions(-)

--- a/jaraco/itertools.py
+++ b/jaraco/itertools.py
@@ -172,7 +172,10 @@
 
 	def __iter__(self):
 		while True:
-			yield next(self)
+			try:
+				yield next(self)
+			except StopIteration:
+				return
 
 	def enqueue(self, item):
 		self.put_nowait(item)
@@ -556,8 +559,11 @@
 	"""
 	items = iter(iterable)
 	while True:
-		yield next(items)
-		next(items)
+		try:
+			yield next(items)
+			next(items)
+		except StopIteration:
+			return
 
 def remove_duplicates(iterable, key=None):
 	"""
